#include<bits/stdc++.h>
#define MAXN 500007
using namespace std;

const long long inf=1e9;

int pt,n,a[MAXN],b[MAXN],c[MAXN];
int from[MAXN];
long long dp[MAXN];

struct line{
    long long a,b;
    long long from;

    long long val(long long x){
        return a*x+b;
    }
};

long long intersec(line fr,line sc){
    long long x=(sc.b-fr.b)/(fr.a-sc.a);

    if(sc.val(x)<fr.val(x))x++;
    if(sc.val(x-1)>fr.val(x-1))x--;

    return x;
}

struct CHT{
    deque<line> d;

    void addline(line s){
        //while(!d.empty() and s.val(d.back().from)>=d.back().val(d.back().from)){
        //    d.pop_back();
       // }

        if(d.empty())d.push_back({s.a,s.b,-inf});
        else d.push_back({s.a,s.b,intersec(d.back(),s)});
    }

    long long query(long long x,long long mina){
        /*while(d[0].a<mina){
            d.pop_front();
            d[0].from=-inf;
        }

        int l=-1,r=d.size(),tt;
        while(l+1<r){
            tt=(l+r)/2;
            if(d[tt].from<=x){
                l=tt;
            }else{
                r=tt;
            }
        }*/

        long long res=-inf;
        for(int i=0;i<d.size();i++){
            if(d[i].a<mina)continue;
            res=max(res,d[i].val(x));
        }

        return res;
    }
};

CHT even,odd;

pair<int,int> tree[4*MAXN];

pair<int,int> combine(pair<int,int> fr,pair<int,int> sc){
    return {min(fr.first,sc.first),max(fr.second,sc.second)};
}

void build(int v,int l,int r){
    if(l==r){
        tree[v]={b[l],c[l]};
    }else{
        int tt=(l+r)/2;
        build(2*v,l,tt);
        build(2*v+1,tt+1,r);

        tree[v]=combine(tree[2*v],tree[2*v+1]);
    }
}

pair<int,int> info(int v,int l,int r,int ll,int rr){
    if(ll>rr)return {0,0};
    if(l==ll and r==rr)return tree[v];

    int tt=(l+r)/2;
    return combine(  info(2*v,l,tt,ll,min(tt,rr)) , info(2*v+1,tt+1,r,max(tt+1,ll),rr) );
}

bool good(int l,int r){
    int mid=(l+r)/2;

    pair<int,int> s=info(1,1,n,l,mid);
    if(s.first<1-l)return false;

    pair<int,int> t=info(1,1,n,mid+1,r);
    if(t.second<1-r)return false;

    return true;
}

int main(){

    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    cin>>n;
    for(int i=1;i<=n;i++){
        cin>>a[i];

        b[i]=a[i]-i;
        c[i]=a[i]-(n-i+1);
    }
    build(1,1,n);

    pt=n;
    for(int i=n;i>=1;i--){
        while(pt-1>=1 and good(pt-1,i))pt--;
        from[i]=pt;
    }

    even.addline({0,0,0});

    for(int i=1;i<=n;i++){
        if(i%2==1){
            if(from[i]%2==0)from[i]++;

            dp[i]=even.query(-i/2-1,from[i]/2) + (i/2+1)*(i/2+1);
            odd.addline({2*(i/2+1),dp[i]+(i/2+1)*(i/2+1) - 2*(i/2+1),0});
        }else{
            if(from[i]%2==1)from[i]++;
            
            dp[i]=odd.query(-i/2,from[i]/2+1) + i*i/4 + 2*(i/2) + 1;
            even.addline({i,dp[i]+i*i/4,0});
        }
    }

    cout<<dp[n]<<"\n";

    return 0;
}