#include <iostream>
#include <cmath>
#include <set>
#include <unordered_set>
using namespace std;

multiset<int> f(multiset<int> m, int k) {
    multiset<int> result;
    for (int e : m) {
        result.insert(e ^ k);
    }
    return result;
}

int main() {
    int n, L, x;
    multiset<int> m;
    cin >> n >> L;
    for (int i = 0; i < n; i++) {
        cin >> x;
        m.insert(x);
    }

    int endNum = pow(2, L);

    set<multiset<int>> u;

    for (int i = 0; i < endNum; i++) {
        multiset<int> current = f(m, i);
        /*for (int elem : current) {
            cout << elem << ", ";
        }
        cout << endl;*/
        u.insert(current);
    }

    cout << u.size() << endl;
}
