#include "circle.h"
//#include "Lgrader.cpp"
#include <algorithm>
#include <array>
#include <cassert>
#include <climits>
#include <cmath>
#include <iomanip>
#include <iostream>
#include <map>
#include <random>
#include <unordered_map>
#include <vector>
using namespace std;
pair<double, pair<double,double>> ORad(pair<double,double> p1,pair<double,double> p2,pair<double,double> p3){
    double a=p1.first,b=p1.second;
    double c=p2.first,d=p2.second;
    double e=p3.first,f=p3.second;
    double d1=(2*d-2*b),d2=(2*a-2*c),d3=(a*a+b*b-c*c-d*d);
    double k=d1/d2,s=d3/d2;
    d1=2*a*s-a*a-b*b-2*e*s+e*e+f*f;
    d2=(-2)*(a*k+b-e*k-f);
    double y=d1/d2;
    double x=y*k+s;
    double r=sqrt((x-a)*(x-a)+(y-b)*(y-b));
    return {r,{x,y}};
}
map<pair<double,pair<double,double>>,int> m;
pair<double, double> pnts[1000];
pair<double,pair<double,double>> curans,anss[21];
void outt(pair<double,pair<double,double>> pp){
    cout<<pp.second.first<<" "<<pp.second.second<<" "<<pp.first<<"n";
}
int curansval=0,ind=0;
double st=214.45;
void solve(int k){
    srand(50);
    int n=500;
    for(int i=0;i<n;i++){
        pnts[i]=sample_star();
        pnts[i].first+=st;
        pnts[i].second+=st;
    }
    int br=0;
    for(int i0=0;;i0++){
        int beg=rand()%470;
        for(int i=beg;i<n;i++){
            for(int i1=i+1;i1<n;i1++){
                if(pnts[i].first==pnts[i1].first || pnts[i].second==pnts[i1].second) continue;
                for(int i2=i1+1;i2<n;i2++){
                    if(pnts[i].first==pnts[i2].first || pnts[i].second==pnts[i2].second) continue;
                    if(pnts[i2].first==pnts[i1].first || pnts[i2].second==pnts[i1].second) continue;
                    pair<double,pair<double,double>> ans=ORad(pnts[i1],pnts[i],pnts[i2]);
                    m[ans]++;
                   // outt(ans);
                    int g=m[ans];
                    if(g>curansval){
                        curans=ans;
                        curansval=g;
                    }
                    br++;
                    if(br>=3000) break;
                }
                    if(br>=3000) break;
            }
                    if(br>=3000) break;
        }
        br=0;
        bool da=false;
        for(int i=0;i<ind;i++){
            double raz1=anss[i].first-curans.first;
            double raz2=anss[i].second.first-curans.second.first;
            double raz3=anss[i].second.second-curans.second.second;
            if(abs(raz1)<0.1 && abs(raz3)<0.0001 && abs(raz2)<0.0001){
                da=true;
                break;
            }
        }
        curansval=0;
        if(da) continue;
        anss[ind]=curans;
        ind++;
        if(ind==2) break;
    }
    //anss[0].second.first=st;
    for(int i=0;i<ind;i++){
        cout<<anss[i].second.first-st<<" "<<anss[i].second.second-st<<" "<<anss[i].first<<"\n";
        answer(anss[i].second.first, anss[i].second.second, anss[i].first);
    }
}
