#include <bits/stdc++.h>
#define endl '\n'
using namespace std;

const int MAXN = 5000 + 1;
int a[MAXN];
int n;

int mina[MAXN][MAXN];

long long dp[MAXN];

inline long long sum(int L, int R)
{
    if (L == R) return 1;

    long long sum = 0;
    int cnt = 0;
    int m = (R+L) >> 1;

    if (mina[L][m] < m-L+1)
    {
        for (int j = L; j <= m; j++)
        {
            cnt++;
            if (a[j] < cnt) return -2e9;
            sum += cnt;
        }
    } else {
        cnt = m-L+1;
        sum += cnt*(cnt+1)/2;
    }

    if (mina[m+1][R] < R-m)
    {
        for (int j = m + 1; j <= R; j++)
        {
            cnt--;
            if (a[j] < cnt) return -2e9;
            sum += cnt;
        }
    } else {
        sum += cnt*(cnt-1)/2;
    }

    return sum;
}

int main()
{
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    cin >> n;

    for (int i = 1; i <= n; i++)
        cin >> a[i];

    for (int L = 1; L <= n; L++)
    {
        mina[L][L] = a[L];
        for (int R = L+1; R <= n; R++)
        {
            mina[L][R] = min(mina[L][R-1], a[R]);
        }
    }

    for (int i = 0; i <= n; i++)
    {
        int L = i + 1;

        for (int R = L; R <= n; R += 2)
        {
            long long s = sum(L, R);

            if (s < 0) break;
            dp[R] = max(dp[R], dp[i] + s);
        }
    }

    cout << dp[n] << endl;

    return 0;
}
/**
7
3 1 4 2 5 9 2
----
11

11
2 1 2 3 2 1 4 3 6 2 1
----
19

*/
