#include<bits/stdc++.h>
#define endl '\n'
#define fi first
#define se second

using namespace std;

const int MAXN=5e5+5;
const int INF=2e18;

struct Line
{
    double k,m;
    Line() {};
    Line(double _k,double _m)
    {
        k=_k;
        m=_m;
    }
};

struct HL
{
    Line t;
    double st;
    int num;
    HL() {};
    HL(Line _t,double _st,int _num)
    {
        t=_t;
        st=_st;
        num=_num;
    }
};

int n;
int a[MAXN];
int l[MAXN];
long long dp[MAXN];
deque<HL> hull[2];

double intersect(Line t1,Line t2)
{
    return (t2.m-t1.m)/(t1.k-t2.k); ///
}

void add(Line t,int num,int p)
{
    if(hull[p].size()<1)
    {
        hull[p].push_front(HL(t,INF,num));
        return;
    }
    if(hull[p].size()<2)
    {
        hull[p].push_front(HL(t, intersect(hull[p].front().t, t), num));
        return;
    }
    while(hull[p].size()>=2 && intersect(t, hull[p][1].t) > hull[p].front().st) hull[p].pop_front();
    hull[p].push_front(HL(t,intersect(t, hull[p].front().t), num));
}

void remove1(int p)
{
    hull[p].pop_back();
    HL cur=hull[p].back();
    hull[p].pop_back();
    cur.st=-INF;
    hull[p].push_back(cur);
}

int bs(int x,int p) /// !!! db
{
    int l=0, r=hull[p].size()-1;
    while(l<r)
    {
        int mid=(l+r)/2;
        if(x>hull[p][mid].st) l=mid+1;
        else r=mid;
    }
    return l;
}

int main()
{
ios::sync_with_stdio(false);
cin.tie(NULL);
cout.tie(NULL);

cin>>n;
for(int i=1;i<=n;i++) cin>>a[i];

for(int i=1;i<=n;i++) l[i]=1;
for(int i=1;i<=n;i++)
{
    if(i+a[i]<=n) l[i+a[i]]=max(l[i+a[i]], i-a[i]+1);
}
for(int i=2;i<=n;i++) l[i]=max(l[i], l[i-1]);

//for(int i=1;i<=n;i++) cout<<l[i]<<" "; cout<<endl;

dp[0]=0;
add(Line(0,0), 0, 0);
dp[1]=1;
add(Line(-0.5, 0.75), 1, 1);
for(int i=2;i<=n;i++)
{
    int p=(i-1)%2;
    while(hull[p].size()>=2 && hull[p].back().num<l[i]-1) remove1(p);
    //cout<<i<<" "<<hull[p].size()<<" "<<hull[p].front().num<<endl;
    int ind=bs(i,p);
    int j=hull[p][ind].num;
    //cout<<ind<<" "<<j<<endl;
    long long d=(i-j+1)/2;
    dp[i]=max(dp[i], dp[j]+d*d);
    add(Line((double)-i/2, dp[i]+(double)(i*i-2*i)/4.0), i, p^1);
}

cout<<dp[n]<<endl;

return 0;
}
