#include <iostream>
#include <set>
using namespace std;
int n, L;
const int MAX_N = 100000;
const int MAX_L = 20;
multiset<int> sets[1 << MAX_L];
int initialSet[MAX_N];
int main()
{

    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    cin >> n >> L;


    for(int i = 0; i < n; i++)
    {
        cin >> initialSet[i];
    }

    int differentSets = 0;
    for(int k = 0; k < (1 << L); k++) {
        for(int i = 0; i < n; i++) {
            sets[k].insert(initialSet[i] ^ k);
        }
        differentSets++;
        for(int i = k - 1; i >= 0; i--) {
            if(sets[i] == sets[k]) {
                differentSets--;
                break;
            }
        }
    }
    cout << differentSets;
    return 0;
}
