#define ll int64_t

#include<bits/stdc++.h>
#include "circle.h"
using namespace std;

struct point{
    double x,y;
};
struct line{
    double k,b;
};

point pts[10];

line findL(point A, point B){
    line ans;
    ans.k=(B.y-A.y)/(B.x-A.x);
    ans.b=A.y-ans.k*A.x;
    return ans;
}

line findS(point A, point B){
    line AB=findL(A,B);
    point M;
    M.x=(A.x+B.x)/2;
    M.y=(A.y+B.y)/2;
    //cout<<AB.k<<" "<<AB.b<<endl;
    line sAB;
    sAB.k=-(1/AB.k);
    sAB.b=M.y-sAB.k*M.x;

    return sAB;
}
bool f[10];
bool F=0;
point findC(point A, point B, point C){
        //if(F) while(1);
    line s1,s2;
    if(C.y==B.y){
        s1=findS(A,C);
        s2=findS(B,A);
    }
    else if(A.y==C.y){
        s1=findS(A,B);
        s2=findS(B,C);
    }
    else{
        s1=findS(C,B);
        s2=findS(A,C);
    }

    /*cout<<s1.k<<s1.b<<endl;
    cout<<s2.k<<s2.b<<endl;*/

    point cen;
    cen.x=(s2.b-s1.b)/(s1.k-s2.k);
    cen.y=cen.x*s1.k+s1.b;
    return cen;
}

double dist(point a, point b){
    return sqrt((a.x-b.x)*(a.x-b.x)+(a.y-b.y)*(a.y-b.y));
}


void solve(int k){
    for(ll i=1;i<=7;i++){
        auto tp=sample_star();
        pts[i].x=tp.first;
        pts[i].y=tp.second;
    }


    point c;
    double r;
    for(ll i1=1;i1<=4;i1++){
        for(ll i2=i1+1;i2<=5;i2++){
            for(ll i3=i2+1;i3<=6;i3++){
                for(ll i4=i3+1;i4<=7;i4++){
                    point c1=findC(pts[i1],pts[i2],pts[i3]);
                    point c2=findC(pts[i1],pts[i2],pts[i4]);
                    if(c1.x==c2.x && c1.y==c2.y){
                        r=sqrt((c1.x-pts[i1].x)*(c1.x-pts[i1].x)+(c1.y-pts[i1].y)*(c1.y-pts[i1].y));
                        c=c1;
                        answer(c1.x,c1.y,r);
                        f[i1]=f[i2]=f[i3]=f[i4]=1;
                        //cout<<i1<<endl<<i2<<endl<<i3<<endl<<i4<<endl;
                        F=1;
                        break;
                    }
                }
                if(F) break;
            }
            if(F) break;
        }
        if(F) break;
    }

    double diff=1e-3;
    for(ll i=1;i<=7;i++){
        if(f[i]==0 && dist(c,pts[i])-r<=diff) f[i]=1;
    }

    ll br=0;
    point t[3];
    for(ll i=1;i<=7;i++){
        if(f[i]==0){
                //cout<<i<<endl;
            t[br]=pts[i];
            br++;
        }
    }

    while(br<3){
        auto tp=sample_star();
        point tpp;
        tpp.x=tp.first;
        tpp.y=tp.second;
        if(dist(c,tpp)-r>diff){t[br]=tpp; br++;}
    }

    point c1=findC(t[0],t[1],t[2]);

    r=dist(c1,t[0]);
    //while(1);
    answer(c1.x,c1.y,r);
}

/*int main()
{
    point A={0,0};
    point B={1,0};
    point C={0,1};
    point cen=findC(A,B,C);
    cout<<cen.x<<" "<<cen.y;
}*/
