#include<bits/stdc++.h>
#include "circle.h"
using namespace std;
vector<pair<double,double>> order;
double surface(double a, double b, double c)
{
    double p=(a+b+c)/2;
    double s=p*(p-a);s*=(p-b);s*=(p-c);
    return sqrt(s);
}
double radius(double a, double b, double c)
{
    double s=surface(a,b,c);
    double r=a*b*c;r/=s;r/=4.0;
    return r;
}
double calc(pair<double,double> p1, pair<double,double> p2)
{
    double lenx=abs(p2.first-p1.first);lenx*=lenx;
    double leny=abs(p2.second-p1.second);leny*=leny;
    return sqrt(lenx+leny);
}
pair<double,double> center(pair<double,double> x0, pair<double,double> x1, pair<double,double>x2, double r)
{
    double cx,cy,l1=2*(x1.first-x0.first),r1=2*(x1.second-x0.second);
    double l2=2*(x2.first-x0.first),r2=2*(x2.second-x0.second);
    double val1=(r*r) - (x0.first*x0.first) - (x0.second*x0.second);
    double val2=(r*r) - (x1.first*x1.first) - (x1.second*x1.second);
    double val3=(r*r) - (x2.first*x2.first) - (x2.second*x2.second);
    double f=val1-val2,g=val1-val3;
    double ogr=r1,ogf=f;
    r1*=l2;f*=l2;
    r2*=l1;g*=l1;
    cy=(f-g)/(r1-r2);
    cx=(ogf-(cy*ogr))/l1;
    return {cx,cy};
}
void solve(int k)
{
    for(int i=1;i<=400;i++)order.push_back(sample_star());
    sort(order.begin(),order.end());
    pair<double,double> x1=order[0],x2=order[1],x3=order[2],x4=order[order.size()-1];
    pair<double,double> x5=order[order.size()-2],x6=order[order.size()-3];

    double a1=calc(x1,x2),b1=calc(x2,x3),c1=calc(x1,x3),p1=(a1+b1+c1)/2;
    double r1=radius(a1,b1,c1);
    pair<double,double> res1=center(x1,x2,x3,r1);
    answer(res1.first,res1.second,r1);

    double a2=calc(x4,x5),b2=calc(x5,x6),c2=calc(x4,x6),p2=(a2+b2+c2)/2;
    double r2=radius(a2,b2,c2);
    pair<double,double> res2=center(x4,x5,x6,r2);
    answer(res2.first,res2.second,r2);
}
