#include<bits/stdc++.h>
#define MAXN 500007
using namespace std;

int pt,n,a[MAXN],b[MAXN],c[MAXN];
int from[MAXN];
long long dp[MAXN];

pair<int,int> tree[4*MAXN];

pair<int,int> combine(pair<int,int> fr,pair<int,int> sc){
    return {min(fr.first,sc.first),max(fr.second,sc.second)};
}

void build(int v,int l,int r){
    if(l==r){
        tree[v]={b[l],c[l]};
    }else{
        int tt=(l+r)/2;
        build(2*v,l,tt);
        build(2*v+1,tt+1,r);

        tree[v]=combine(tree[2*v],tree[2*v+1]);
    }
}

pair<int,int> info(int v,int l,int r,int ll,int rr){
    if(ll>rr)return {0,0};
    if(l==ll and r==rr)return tree[v];

    int tt=(l+r)/2;
    return combine(  info(2*v,l,tt,ll,min(tt,rr)) , info(2*v+1,tt+1,r,max(tt+1,ll),rr) );
}

bool good(int l,int r){
    int mid=(l+r)/2;

    pair<int,int> s=info(1,1,n,l,mid);
    if(s.first<1-l)return false;

    pair<int,int> t=info(1,1,n,mid+1,r);
    if(t.second<1-r)return false;

    return true;
}

int main(){

    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    cin>>n;
    for(int i=1;i<=n;i++){
        cin>>a[i];

        b[i]=a[i]-i;
        c[i]=a[i]-(n-i+1);
    }
    build(1,1,n);

    pt=n;
    for(int i=n;i>=1;i--){
        while(pt-1>=1 and good(pt-1,i))pt--;
        from[i]=pt;
    }

    for(int i=1;i<=n;i++){
        for(int f=i;f>=from[i];f-=2){
            dp[i]=max(dp[i],(long long) dp[f-1]+(i-f+2)*(i-f+2)/4);
        }
    }

    cout<<dp[n]<<"\n";

    return 0;
}