#include <bits/stdc++.h>
using namespace std;

template< class T, class T2 > inline bool chkmin( T& a, const T2& b ){ return a > b ? a = b, 1 : 0; }
template< class T, class T2 > inline bool chkmax( T& a, const T2& b ){ return a < b ? a = b, 1 : 0; }


#ifndef LOCAL
#define cerr if(false) cerr
#endif // LOCAL

#define out(x) #x << " = " << x << "  "

typedef long long ll;

const int MAX_N = 1e6 + 42;
const ll inf = -1e17;

ll dp[MAX_N];
ll a[MAX_N];
int n;


bool f( int st, int dist ){
    if( st + dist >= n ) return false;
    int curr = 1;
    int add = 1;

    bool oke = true;
    for( int k=st ; k <= st+dist ; k++ ){

        if( a[k] < curr ){
            oke = false;
            break;
        }

        if( k == ( st + st+dist )/2 ) add = -1;
        curr += add;
    }
    return oke;
}

struct Point{
    ll a, b;

    Point( ll _a, ll _b ){
        a = _a;
        b = _b;
    }

    ll calc( ll x ){
        return a * x + b;
    }
};

double inter( const Point& a, const Point& b ){
    /// a1x + b1 = a2x + b2
    /// x( a1 - a2 ) = b2 - b1
    /// x = ( b2 - b1 ) / ( a1 - a2 )

    double nas = ( b.b - a.b ) / ( a.a - b.a );
    return nas;
}

int main (){

#ifndef LOCAL
 std::ios_base::sync_with_stdio(false); std::cin.tie( NULL ); std::cout.tie( NULL );
#endif // LOCAL

    std::cin >> n;

    for( int i= 0 ; i < n ; i++ ) std::cin >> a[i];


    std::deque< std::pair< Point, int > > qCh;
    std::deque< std::pair< Point, int > > qNech;
    for( int i=n-1 ; i >= 0 ; i-- ){
        dp[i] = dp[i+1] + 1;

        int l = 0, r = n;
        while( l != r-1 ){
            int m = ( l + r ) >> 1;
            int currM = ( m / 2 ) * 2;
            if( f( i, currM ) ) l = m;
            else r = m;
        }

        int dist = ( l/2 ) * 2;
        cerr << out( dist ) << endl;

    cerr << out( i ) << endl;
    if( i&1 ){
        cerr << " nech " << endl << endl;
        while( ( qNech.size() and qNech.back().second > i + dist ) ||
            ( qNech.size() > 1 and qNech.back().first.calc( i ) < qNech[qNech.size()-2].first.calc( i ) ) ) qNech.pop_back();

        cerr << " CHT " << endl;
        for( auto j : qNech ){
            cerr << j.first.a << " " << j.first.b << " ; " << j.second << endl;
        }
        cerr << endl;

        if( !qNech.empty() ){
            cerr << " zele " << endl;
            ll curr = qNech.back().first.calc( i );
            chkmax( dp[i], i*i + curr / 4);
            cerr << out( i * i ) << " + " << out( curr ) << endl << endl;
        }

        Point currP( -2*i, i*i + 4*dp[i+1] );
        cerr << " currP " << out( i*i )<< " + " << out( dp[i+1] ) << " , " << out( -2*i ) << endl;
        while( qNech.size() > 1 and inter( currP, qNech[1].first ) > inter( qNech.front().first, qNech[1].first )) qNech.pop_front();
        qNech.push_front({ currP, i });
    }else{
        cerr << " chetni " << endl << endl;

        while( ( qCh.size() and qCh.back().second > i + dist ) || ( qCh.size() > 1 and qCh.back().first.calc( i ) < qCh[qCh.size()-2].first.calc( i ) ) ) qCh.pop_back();

        cerr << " CHT " << endl;
        for( auto j : qCh ){
            cerr << j.first.a << " " << j.first.b << " ; " << j.second << endl;
        }
        cerr << endl;

        ll curr = -inf;
        if( !qCh.empty() ){
            cerr << " zele " << endl;
            curr = qCh.back().first.calc( i );
            chkmax( dp[i], i*i + curr / 4);
            cerr << out( i * i ) << " + " << out( curr ) << endl << endl;
        }

        Point currP( -2*i, i*i + 4*dp[i+1] );
        cerr << " currP " << out( i*i )<< " + " << out( dp[i+1] ) << " , " << out( -2*i ) << endl;
        while( qCh.size() > 1 and inter( currP, qCh[1].first ) > inter( qCh.front().first, qCh[1].first )) qCh.pop_front();
        qCh.push_front({ currP, i });

    }
        cerr << out( dp[i] ) << endl;

    }

    std::cout << dp[0] << endl;

    return 0;
}
