#include<iostream>
#include<set>
#include<algorithm>

#define MAXN 100001

using namespace std;

int n, l, arr[MAXN];

pair<pair<long long, long long>, long long> h[2000000];
pair<pair<long long, long long>, long long> init(int a[])
{
    long long base = 69420, MOD = 1e9;
    long long hsh1 = 0, hsh2 = 0, hsh3 = 0;
    for(int i = 1; i <= n; i ++)
    {
        hsh1 = (hsh1 * base + a[i - 1]) % MOD;
    }
    base = 12345;
    MOD = 1e9+9;
    for(int i = 1; i <= n; i ++)
    {
        hsh2 = (hsh2 * base + a[i - 1]) % MOD;
    }
    base = 6;
    MOD = 1e6;
    for(int i = 1; i <= n; i ++)
    {
        hsh3 = (hsh3 * base + a[i - 1]) % MOD;
    }
    return {{hsh1, hsh2}, hsh3};
}

set<pair<pair<long long, long long>, long long>> s;

void read()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    cin>>n>>l;
    for(int i = 0; i < n; i ++)
    {
        cin>>arr[i];
    }
}
void solve()
{
    for(int k = 0; k < (1 << l); k ++)
    {
        int newArr[MAXN];
        for(int i = 0; i < n; i ++)
        {
            newArr[i] = arr[i] ^ k;
        }
        sort(newArr, newArr + n);

        h[k] = init(newArr);
        /*for(int i = 0; i < n; i ++)
        {
            cout<<newArr[i]<<' ';
        }*/
        //cout<<"| "<<h[k].first.first<<" "<<h[k].first.second<<" "<<h[k].second<<endl;
        s.insert(h[k]);
    }
    cout<<s.size()<<endl;
}
int main()
{
    read();
    solve();
    return 0;
}

