#include <bits/stdc++.h>
#define endl '\n'
using namespace std;

const int MAXN = 500000 + 1;
int a[MAXN];
int n;

long long dp[10000][10000];

long long rec(int L, int R)
{
    if (L > n || R > n) return 0;
    if (dp[L][R]) return dp[L][R];

    long long sum = 0;
    int cnt = 0;

    for (int i = L; i <= (R+L)/2 && i > 0; i++)
    {
        cnt++;
        if (a[i] < cnt) return -2e9;
        sum += cnt;
    }

    for (int i = (R+L)/2 + 1; i <= R && i > 0; i++)
    {
        cnt--;
        if (a[i] < cnt) return -2e9;
        sum += cnt;
    }

    long long ret = 0;
    for (int i = R + 1; i <= n; i += 2)
    {
        ret = max(ret, rec(R+1, i));
    }

    ret += sum;

    dp[L][R] = ret;
    return ret;
}

int main()
{
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    cin >> n;

    for (int i = 1; i <= n; i++)
        cin >> a[i];

    cout << rec(0, 0) << endl;

    return 0;
}
/**
7
3 1 4 2 5 9 2
----
11

11
2 1 2 3 2 1 4 3 6 2 1
----
19

*/
