#include <bits/stdc++.h>
#define endl '\n'
using namespace std;

const int MAXN = 500000 + 1;
int a[MAXN];
int n;

long long dp[MAXN];

long long sum(int L, int R)
{
    long long sum = 0;
    int cnt = 0;

    for (int j = L; j <= (R+L)/2; j++)
    {
        cnt++;
        if (a[j] < cnt) return -2e9;
        sum += cnt;
    }

    for (int j = (R+L)/2 + 1; j <= R; j++)
    {
        cnt--;
        if (a[j] < cnt) return -2e9;
        sum += cnt;
    }
    return sum;
}

long long rec(int ind)
{
    if (ind > n) return 0;
    if (dp[ind]) return dp[ind];

    int L = ind + 1;

    long long ret = 0;
    for (int R = L; R <= n; R += 2)
    {
        ret = max(ret, rec(R) + sum(L, R));
    }

    dp[ind] = ret;
    return ret;
}

int main()
{
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    cin >> n;

    for (int i = 1; i <= n; i++)
        cin >> a[i];

    cout << rec(0) << endl;

    return 0;
}
/**
7
3 1 4 2 5 9 2
----
11

11
2 1 2 3 2 1 4 3 6 2 1
----
19

*/
