#include <bits/stdc++.h>
#define endl '\n'
using namespace std;

const int MAXN = 500000 + 1;
int a[MAXN];
int n;

long long dp[MAXN];

inline long long sum(int L, int R)
{
    long long sum = 0;
    int cnt = 0;

    for (int j = L; j <= (R+L)/2; j++)
    {
        cnt++;
        if (a[j] < cnt) return -2e9;
        sum += cnt;
    }

    for (int j = (R+L)/2 + 1; j <= R; j++)
    {
        cnt--;
        if (a[j] < cnt) return -2e9;
        sum += cnt;
    }
    return sum;
}

int main()
{
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    cin >> n;

    for (int i = 1; i <= n; i++)
        cin >> a[i];

    for (int i = 0; i <= n; i++)
    {
        int L = i + 1;

        for (int R = L; R <= n; R += 2)
        {
            dp[R] = max(dp[R], dp[i] + sum(L, R));
        }
    }

    cout << dp[n] << endl;

    return 0;
}
/**
7
3 1 4 2 5 9 2
----
11

11
2 1 2 3 2 1 4 3 6 2 1
----
19

*/
