#include<iostream>
#include<algorithm>
#include<vector>
using namespace std;

const long long MAXN = 5000002;
long long n;
long long sum = 0, maxSum = 0;
vector <long long> a;


void Read() {
    long long x;
    cin >> n;
    for (long long i=0; i<n; i++) {
        cin >> x;
        a.push_back(x);
    }

    for (long long i=0; i<n; i++) {
        if (i == 0) {
            if (a[i] > a[i + 1]) a[i] = a[i + 1] + 1;
        } else if(i == n - 1) {
            if (a[i] > a[i - 1]) a[i] = a[i - 1] + 1;
        } else {
            long long tmp = max(a[i - 1], a[i + 1]);
            if (a[i] > tmp) a[i] = tmp + 1;
        }
    }
}

bool Check(long long k) {
    for (long long i=1; i<a[k]; i++) {
        if (k - i < 0) return false;
        if (k + i > a.size() - 1) return false;
        if (a[k + i] < a[k] - i) return false;
        if (a[k - i] < a[k] - i) return false;
    }
    return true;
}

long long FindSum(long long x) {
    long long sumi = x;
    for (long long i=1; i<x; i++)
        sumi += 2 * i;
    return sumi;
}

void Solve() {
    long long maxi = 0;
    bool found = false;
    for (long long i=0; i<a.size(); i++) {
        if (a[i] > maxi) maxi = a[i];
    }

    for (long long i=0; i<a.size(); i++) {
        if (a[i] == maxi) {
            if (Check(i)) {
                found = true;
                vector<long long> b = a;
                a.erase(a.begin() + i - maxi + 1, a.begin() + i + maxi);
                sum += FindSum(maxi);
                Solve();
                a = b;
            }
            else a[i] -= 1;
        }
    }
    for (long long i=0; i<a.size(); i++)
        if (a[i] == maxi) a[i] -= 1;

    if (a.size() == 0) {
        if (sum > maxSum) maxSum = sum;
        sum = 0;
        return;
    }
    if (!found) Solve();
}

int main() {
    Read();
    Solve();
    cout << maxSum << endl;
}
