#include<bits/stdc++.h>
#include "circle.h"
using namespace std;
const double eps=0.000001;
const double inf=999999999;
struct star{
    double x;
    double y;
    vector<int>lis;
};
struct line{
    double a;
    double b;
    int s1i,s2i;
    //ax+b
};
struct circle{
    double x;
    double y;
    double r,r2;
};
vector<star>stars;
vector<line>lines;
vector<circle>pcir,cir;
double dist2(double ax,double ay,double bx,double by){
    return (ax-bx)*(ax-bx)+(ay-by)*(ay-by);
}
void encircle(line l1,line l2){
    double x=(l2.b-l1.b)/(l1.a-l2.a);
    circle c;
    c.x=x;
    c.y=l1.a*x+l1.b;
    star s=stars[l1.s2i];
    c.r2=dist2(c.x,c.y,s.x,s.y);
    pcir.push_back(c);
    //cout<<"newc at "<<c.x<<" "<<c.y<<" "<<c.r2<<" sx "<<s.x<<" sy "<<s.y<<endl;
}
void cross(int s1i,int s2i){
    star s2=stars[s2i];
    star s1=stars[s1i];
    double a;
    if(s2.x-s1.x!=0)a=(s2.y-s1.y)/(s2.x-s1.x);
    else a=inf;
    double cx=(s1.x+s2.x)/2,cy=(s1.y+s2.y)/2;
    double ca;
    if(a!=inf)ca=-1/a;
    else ca=0;
    double cb;
    if(a!=inf)cb=cy-cx*ca;
    else cb=cy;
    line l;
    l.a=ca;
    l.b=cb;
    l.s1i=s1i;
    l.s2i=s2i;
    for(int i=0;i<s2.lis.size();i++){
        line l2=lines[s2.lis[i]];
        encircle(l,l2);
    }
    stars[s2i].lis.push_back(lines.size());
    stars[s1i].lis.push_back(lines.size());
    //cout<<"newl"<<endl;
    lines.push_back(l);
}
void solve(int k){
    int ans=0;
    while(ans<k){
        //cout<<"next"<<endl;
        pair<double,double> sq=sample_star();
        star s;
        s.x=sq.first;
        s.y=sq.second;
        bool ok=0;
        for(int j=0;j<cir.size();j++){
            if(abs(dist2(s.x,s.y,cir[j].x,cir[j].y)-cir[j].r2)<eps){
                ok=1;
                //cout<<"same"<<endl;
                break;
            }else{
                //cout<<"nsame"<<endl;
            }
        }
        if(ok)continue;
        for(int j=0;j<pcir.size();j++){
            if(abs(dist2(s.x,s.y,pcir[j].x,pcir[j].y)-pcir[j].r2)<eps){
                ok=1;
                cir.push_back(pcir[j]);
                answer(pcir[j].x,pcir[j].y,sqrt(pcir[j].r2));
                ans++;
                //cout<<"is"<<endl;
                break;
            }
            else{
                //cout<<"not "<<dist2(s.x,s.y,pcir[j].x,pcir[j].y)-pcir[j].r2<<endl;
            }
        }
        if(ok)continue;
        for(int j=0;j<stars.size();j++){
            if(abs(dist2(s.x,s.y,stars[j].x,stars[j].y))<eps){
                ok=1;
                circle c;
                c.x=s.x;
                c.y=s.y;
                c.r2=0;
                cir.push_back(c);
                answer(c.x,c.y,eps);
                ans++;
                //cout<<"is"<<endl;
                break;
            }
            else{
                //cout<<"not "<<dist2(s.x,s.y,pcir[j].x,pcir[j].y)-pcir[j].r2<<endl;
            }
        }
        if(ok)continue;
        stars.push_back(s);
        for(int i=0;i<stars.size()-1;i++){
            cross(stars.size()-1,i);
        }
    }
}
