#include<iostream>
#include<vector>
#include<deque>
#include<set>
#include<cmath>
using namespace std;
const long long MAX_N=5e5+5;
const long long INF=(1LL<<60);
long long n;
long long a[MAX_N];
long long DP[MAX_N];
long long pre[MAX_N];
long long suf[MAX_N];
long long last[MAX_N];
struct line
{
    double m,c;
    long long calc(int x){return 1LL*(1LL*m*x+1LL*c);}
    double intersect(line l){return (c-l.c)/(l.m-m);}
};
deque<line>dp[2][2*MAX_N];
vector<long long>range[2][2*MAX_N];
void add(bool f,line cur,long long wh)
{
    while(dp[f][wh].size()>=2 && cur.intersect(dp[f][wh].back())<=dp[f][wh].back().intersect(dp[f][wh][dp[f][wh].size()-2]))
    {
        dp[f][wh].pop_back();
        range[f][wh].pop_back();
    }
    if(range[f][wh].size()>0)
    {
        range[f][wh].back()=floor(cur.intersect(dp[f][wh].back()));
    }
    dp[f][wh].push_back(cur);
    range[f][wh].push_back(1e9);
}
long long Search(bool f,int x,int wh)
{
    int l=0,r=range[f][wh].size()-1;
    int pos=0;
    while(l<=r)
    {
        int mid=(l+r)/2;
        if(x<=range[f][wh][mid])
        {
            pos=mid;
            l=mid+1;
        }
        else r=mid-1;
    }
    return dp[f][wh][pos].calc(x);
}
line la;
void update(int node,int l,int r,bool f,int idx)
{
    add(f,la,node);
    if(l==r)
    {
        return;
    }
    int mid=(l+r)/2;
    if(idx<=mid)update(2*node,l,mid,f,idx);
    else update(2*node+1,mid+1,r,f,idx);
}
long long query(int node,int l,int r,int ql,int qr,bool f,int x)
{
    if(ql<=l && r<=qr)return Search(f,x,node);
    long long mid=(l+r)/2;
    long long ans=-INF;
    if(ql<=mid)ans=query(2*node,l,mid,ql,qr,f,x);
    if(qr>=mid+1)
    {
        ans=max(ans,query(2*node+1,mid+1,r,ql,qr,f,x));
    }
    return ans;
}
vector<long long>v[MAX_N];
set<long long>s;
signed main ()
{
    ios_base::sync_with_stdio(0);
    cin.tie(NULL);
    cout.tie(NULL);
    cin>>n;
    for(long long i=1;i<=n;i++)
    {
        cin>>a[i];
    }

    s.insert(0);
    for(long long i=1;i<=n;i++)
    {
        for(long long x:v[i])s.insert(x);
        suf[i]=(i-(*(s.rbegin())));
        if(i+a[i]<=n)v[i+a[i]].push_back(i);
    }

    s.clear();
    for(long long i=1;i<=n;i++)v[i].clear();
    s.insert(n+1);
    for(long long i=n;i>=1;i--)
    {
        for(long long x:v[i])s.insert(x);
        pre[i]=((*(s.begin()))-i);
        if(i-a[i]>=1)v[i-a[i]].push_back(i);
    }

    for(long long i=1;i<=n;i++)
    {
        long long l=0,r=i/2;
        long long sz=0;
        while(l<=r)
        {
            long long mid=(l+r)/2;
            long long j=i-2*mid;
            if(suf[i]>=(i-j+1)/2+1 && pre[j]>=(i-j+1)/2+1)
            {
                sz=2*mid;
                l=mid+1;
            }
            else r=mid-1;
        }
        last[i]=i-sz;
    }

    for(long long i=1;i<=n;i++)
    {
        /*for(long long j=i;j>=last[i];j--)
        {
            if(i%2!=j%2)continue;
            DP[i]=max(DP[i],DP[j-1]+((i-j+1)/2+1)*((i-j+1)/2+1));
        }*/
        DP[i]=query(1,0,n/2,(last[i]-1)/2,(i-1)/2,(i-1)%2,-(i+1))+(i+1)*(i+1);
        DP[i]/=4;
        double a=2*i,b=i*i+4*DP[i];
        la={a,b};
        update(1,0,n/2,i%2,i/2);
    }

    cout<<DP[n]<<"\n";

    return 0;
}
