#include<bits/stdc++.h>
#include "circle.h"
using namespace std;
vector<pair<long double,long double>> order;
long double surface(long double a, long double b, long double c)
{
    long double p=(a+b+c)/2.0;
    long double s=p*(p-a);s*=(p-b);s*=(p-c);
    return sqrt(s);
}
long double radius(long double a, long double b, long double c)
{
    long double s=surface(a,b,c);
    long double r=a*b*c;r/=s;r/=4.0;
    return r;
}
long double calc(pair<long double,long double> p1, pair<long double,long double> p2)
{
    long double lenx=abs(p2.first-p1.first);lenx*=lenx;
    long double leny=abs(p2.second-p1.second);leny*=leny;
    return sqrt(lenx+leny);
}
pair<long double,long double> center(pair<long double,long double> x0, pair<long double,long double> x1, pair<long double,long double>x2, long double r)
{
    long double cx,cy,l1=2*(x1.first-x0.first),r1=2*(x1.second-x0.second);
    long double l2=2*(x2.first-x0.first),r2=2*(x2.second-x0.second);
    long double val1=(x0.first*x0.first);val1+=(x0.second*x0.second);
    long double val2=(x1.first*x1.first);val2+=(x1.second*x1.second);
    long double val3=(x2.first*x2.first);val3+=(x2.second*x2.second);
    long double f=val2-val1,g=val3-val1;
    r1*=l2;f*=l2;
    r2*=l1;g*=l1;
    cy=(f-g);cy/=(r1-r2);
    long double del=l1*l2;
    cx=(f-(cy*r1))/del;
    return {cx,cy};
}
void solve(int k)
{
    for(int i=1;i<=10000;i++)order.push_back(sample_star());
    sort(order.begin(),order.end());
    pair<long double,long double> x1=order[0],x2=order[1],x3=order[2],x4=order[order.size()-1];
    pair<long double,long double> x5=order[order.size()-2],x6=order[order.size()-3];

    long double a1=calc(x1,x2),b1=calc(x2,x3),c1=calc(x1,x3),p1=(a1+b1+c1)/2;
    long double r1=radius(a1,b1,c1);
    pair<long double,long double> res1=center(x1,x2,x3,r1);
    answer(res1.first,res1.second,r1);

    long double a2=calc(x4,x5),b2=calc(x5,x6),c2=calc(x4,x6),p2=(a2+b2+c2)/2;
    long double r2=radius(a2,b2,c2);
    pair<long double,long double> res2=center(x4,x5,x6,r2);
    answer(res2.first,res2.second,r2);
}